#ifndef FS_FILEWRITER_IMMEDIATE_H
#define FS_FILEWRITER_IMMEDIATE_H

#include "filewriter.h"

class FileWriterImmediate : public FileWriter
{
public:
	static FileWriterImmediate*	GetFileWriter(const std::string& inName, long long inFileSize);
	static void					Finalize();

	virtual bool				Open(bool inWriteable, int inModTime);
	virtual bool				Close();

	virtual void				GetWriteBuffer(unsigned char*& outBuf, int& outLength);
	virtual bool				ReleaseWriteBuffer(int inRemainingLength);

	virtual bool				IsFinished()	{ return mHandle == INVALID_HANDLE_VALUE; }
	virtual void				HandleAbort();
	
	virtual bool				ChModTime(int inModTime);

private :
								FileWriterImmediate(const std::string& inName, long long inFileSize);

	HANDLE						mHandle;
	static unsigned char*		mBuffer;
};

#endif