#ifndef FS_FILEWRITER_SYNC_H
#define FS_FILEWRITER_SYNC_H

#include "filewriter.h"

class FileWriterSync : public FileWriter
{
public:
	static FileWriterSync*		GetFileWriter(const std::string& inName, long long inFileSize);
	static void					Finalize();

	virtual bool				Open(bool inWriteable, int inModTime);
	virtual bool				Close();

	virtual void				GetWriteBuffer(unsigned char*& outBuf, int& outLength);
	virtual bool				ReleaseWriteBuffer(int inRemainingLength);

	virtual bool				IsFinished()	{ return mHandle == INVALID_HANDLE_VALUE; }
	virtual void				HandleAbort();
	
	virtual bool				ChModTime(int inModTime);

private :
								FileWriterSync(const std::string& inName, long long inFileSize);
	bool						Flush();

	HANDLE						mHandle;
	int							mLength;
	static unsigned char*		mBuffer;
};

#endif